#include <stdio.h>
#include "q12.dat"                               // if your want "hanzi"
#include "jfc.c"                               // main lib.

FILE *fp;
unsigned char a[512][512], h[72][80],c;
float b[4096][4096];                           // ibit=-32
short b2[4096][4096];                           // ibit=16
unsigned char b1[4096][4096];
int   n1,n2,ibit,m1,m2;
float sky;
float d1,d2,d3,d4;
int   skyx,skyy;
float  getsky();

sortx1(a,n)
float *a; int n;
{
  int i,j,k=2,ii,ifin;
  float x;
  while(k<n)k*=2;
  k=(3*k)/4-1; if(n<k)k=n;
l20:
  k/=2;        ifin=n-k;
  for(ii=0;ii<ifin;ii++){
    i=ii;      j=i+k;
    if(a[i]<=a[j])continue;
    x = a[j];
l40:
    a[j]= a[i];
    j=i;       i-=k;
    if(i<0)goto l60;
    if(a[i]>x)goto l40;
l60:
    a[j]=x;
  }
  if(k>1)goto l20;
}

#define MINSKY    20
iraf_sky(bb,i1,i2,skymod,skysig)
int i1,i2; float *bb,*skymod,*skysig;
{
  int   dnsky=i2;
  float hibad=32000.;
  float readns=.0;
  float dskymn,dskymed,dskymod,dsigma,dskew;
  mmm(bb,&dnsky, hibad, readns,&dskymn,&dskymed,&dskymod,&dsigma,&dskew);
  *skymod=dskymod;
  *skysig=dsigma;
//  printf("%f %f %f %f\n",dskymn,dskymed,dskymod,dsigma);
}

mmm(sky,dnsky,hibad,readns, dskymn,dskymed,dskymod,dsigma,dskew)
float sky[];
int   *dnsky;
float hibad, readns;
float *dskymn,*dskymed,*dskymod,*dsigma,*dskew;
{
  double sum,sumsq;
  float  skymn, skymed, skymod, sigma;
  float  cut,cut1,cut2,delta,skymid,r,center,side,dmod,old,clamp;
  int    i,j,k,l,m,minimm,maximm,niter,istep,maxit,jstep,nsky;
  char   redo;

  nsky=*dnsky;
  maxit=30;                      // itet times
  if(nsky <= 0)goto l9900;
  skymid=0.5*(sky[(nsky-1)/2]+sky[nsky/2]);
  sum=0.;
  sumsq=0.;
  cut1=skymid-sky[0];
  if(cut1> sky[nsky-1]-skymid)cut1=sky[nsky-1]-skymid;
  if(cut1> hibad-skymid)cut1=hibad-skymid;
  cut2=skymid + cut1;
  cut1=skymid - cut1;
  minimm=0;
  for(i=1;i<=nsky;i++){                // 1010
    if(sky[i-1] < cut1){ minimm=i; continue; }
    if(sky[i-1] > cut2)goto l1020;
    delta=sky[i-1]-skymid;
    sum+=delta;
    sumsq+=delta*delta;
    maximm=i;
  }
l1020:
  skymed=0.5*(sky[(minimm+maximm-1)/2]+sky[(minimm+maximm)/2]);
  skymn=sum/(maximm-minimm);
  sigma=sqrt(sumsq/(maximm-minimm)-skymn*skymn);
  skymn+=skymid;
  skymod=skymn;
  if(skymed < skymn) skymod=3.*skymed-2.*skymn;

  niter= 0;
  old  = 0.;
  clamp= 1.;
l2000:
  niter++;
  if( (niter > maxit) || (maximm-minimm < MINSKY)) goto l9900;
  r=log10((float)(maximm-minimm));
  r= (-.1042*r+1.1695)*r+.8895;
  if(r<2.)r=2.;
  cut= r*sigma+0.5*abs(skymn-skymod);
  if(cut<1.5)cut=1.5;
  cut1=skymod-cut;
  cut2=skymod+cut;
  redo=0;
  istep=1; if(cut1-sky[minimm]<0.)istep=-1;
  jstep=(istep+1)/2;
  if (istep > 0)goto  l2120;
l2100:
  if ((istep < 0) && (minimm <= 0))goto  l2150;
  if((sky[minimm-1] <= cut1) && (sky[minimm] >= cut1))goto l2150;
l2120:
  delta=sky[minimm+jstep-1]-skymid;
  sum-=istep*delta;
  sumsq-=istep*delta*delta;
  minimm+=istep;
  redo=1;
  goto l2100;
l2150:
  istep=1; if(cut2-sky[maximm-1]<0.)istep=-1;
  jstep=(istep+1)/2;
  if(istep < 0)goto  l2220;
l2200:
  if((istep > 0) && (maximm >= nsky))goto l2250;
  if((sky[maximm-1] <= cut2) && (sky[maximm] >= cut2))goto l2250;
l2220:
  delta=sky[maximm+jstep-1]-skymid;
  sum+=istep*delta;
  sumsq+=istep*delta*delta;
  maximm+=istep;
  redo=1;
  goto l2200;
l2250:
  skymn=sum/(maximm-minimm);
  sigma=sqrt(sumsq/(maximm-minimm)-skymn*skymn);
  skymn+=skymid;
  skymed=0.;
  center = (minimm+1 + maximm)/2.;
  j= nint(0.2*(maximm-minimm));
  side = j/2. + 0.25;
  j = nint(center-side);
  k = nint(center+side);
  l = nint(center-0.25);
  m = nint(center+0.25);
  r = 0.25*readns;
l2305:
  if((j>1)&&(k<nsky)&&((sky[l-1]-sky[j-1]<r)||(sky[k-1]-sky[m-1]<r))){
    j--;    k++;    goto l2305;
  }
  for(i=j;i<=k;i++) skymed+=sky[i-1];
  skymed/=(k-j+1);
  if(skymed < skymn) dmod=3.*skymed-2.*skymn - skymod;
  else dmod=skymn - skymod;
  if (dmod*old < 0.) clamp = 0.5*clamp;
  skymod += clamp*dmod;
  old = dmod ;
  if (redo)goto  l2000;
  if(sigma<1.)sigma=1.;
  *dskew=(skymn-skymod)/sigma;
  *dnsky=maximm-minimm;
  *dskymn=skymn;
  *dskymed=skymed;
  *dskymod=skymod;
  *dsigma=sigma;
  return;
l9900:
  *dsigma=-1.0;
  *dskew=0.0;
  return;
}

float getsky(a,n1,n2,pixelx,pixely)
float a[n2][n1]; int n1,n2,pixelx,pixely;
{
  float x,z,b[2025];
  int i,j,ii,jj,k=0;
  for(jj=pixely-180;jj<pixely+180;jj+=8)for(ii=pixelx-180;ii<pixelx+180;ii+=8){
    x=0.; for(j=jj;j<jj+8;j++)for(i=ii;i<ii+8;i++)x+=a[j][i]; //a[j][i]=0; }
    b[k++]=x/64;
  }
  sortx1(b,k);          // take  0.1~0.5 segement
  iraf_sky(b,1,k,&z,&x);
//  printf("get skyadu at place, x: %d y: %d  skyadu: %f\n",pixelx,pixely,z,x);
  return(z);
}

main(int ac, char **av)
{
  int i,j,k, i1,j1;
  float x,y;
  char f1[20];
  if(ac<2){ printf("\n\t **** show BOK ccd ****\n");
            printf("\n\t Usage: jfmap *.fit [0 0 0 0] [skyx skyy]\n\n\n");
            exit(0);
          }
  d1=d2=d3=d4=0.;
  skyx=skyy=0;
  if(ac>2)sscanf(av[2],"%f",&d1);
  if(ac>3)sscanf(av[3],"%f",&d2);
  if(ac>4)sscanf(av[4],"%f",&d3);
  if(ac>5)sscanf(av[5],"%f",&d4);
  if(ac>6)sscanf(av[6],"%d",&skyx);
  if(ac>7)sscanf(av[7],"%d",&skyy);
  strcpy(f1,av[1]);
  for(i=0;i<strlen(f1);i++)if(f1[i]=='.')break; f1[i]=0; strcat(f1,".fit");
  fp=fopen(f1,"rb"); if(!fp){ printf("%s not found!\n",f1); exit(0); }
  fread(h,72,80,fp); 
  sscanf(&h[1][23],"%d",&ibit);
  sscanf(&h[3][23],"%d",&n1);  
  sscanf(&h[4][23],"%d",&n2); 
  k=indexpos(h,"SKYADU  ",72); sky=0.;
  if(k!=72)sscanf(&h[k][20],"%f",&sky); 
  if(ibit==-32){ fread(b,n1*n2,4,fp); swap4(b,n1*n2*4); }
  if(ibit==16){ fread(b2,n1*n2,2,fp); swap2(b2,n1*n2*2);
                for(j=0;j<n2;j++)for(i=0;i<n1;i++)b[j][i]=b2[j][i]; }
  if(ibit==8){ fread(b1,n1*n2,1,fp); 
                for(j=0;j<n2;j++)for(i=0;i<n1;i++)b[j][i]=b1[j][i]; }
  fclose(fp);
  if(sky!=0)printf("SKYADU  = %6.1f\n",sky);
  if(skyx!=0){ sky=getsky(b,n1,n2,skyx,skyy);
               printf("X,Y,sky: %d %d  %6.1f\n",skyx,skyy,sky); }
  if(sky==0.){ sky=getsky(b,n1,n2,n1/2,n2/2);
               printf("new SKY: %6.1f\n",sky); }
  if(d1+d2+d3+d4!=0.){ 
    x=getsky(b,n1,n2,n1/4,  n2*3/4);   printf("  1sky: %6.1f  ",x);
    x=getsky(b,n1,n2,n1*3/4,n2*3/4);   printf("  3sky: %6.1f\n",x); 
    x=getsky(b,n1,n2,n1/4,    n2/4);   printf("  2sky: %6.1f  ",x); 
    x=getsky(b,n1,n2,n1*3/4,  n2/4);   printf("  4sky: %6.1f\n",x); 
  }
  if(d1!=0.)for(j=n2/2;j<n2;  j++)for(i=0;   i<n1/2;i++)b[j][i]+=d1;
  if(d2!=0.)for(j=0;   j<n2/2;j++)for(i=0;   i<n1/2;i++)b[j][i]+=d2;
  if(d3!=0.)for(j=n2/2;j<n2;  j++)for(i=n1/2;i<n1;  i++)b[j][i]+=d3;
  if(d4!=0.)for(j=0;   j<n2/2;j++)for(i=n1/2;i<n1;  i++)b[j][i]+=d4;
  for(j=0;j<n2;j+=8)for(i=0;i<n1;i+=8){ x=0.;
    for(j1=j;j1<j+8;j1++)for(i1=i;i1<i+8;i1++)x+=b[j1][i1]-sky;
    x*=10./sky;
    x+=64.; if(x<0.)x=0.; if(x>255.)x=255.; a[j/8][i/8]=x;
  }
  x=m1=n1/8; y=m2=n2/8;
  jfbgft(200,235,255,  0,0,0);                   // set BG, front color RGB
  jfbegin("",m1,m2+24,5);                           // "" means no file out
  jfenv(0.,y,0.,x,0);                            // frame define
  jftext(170,508,f1);                          // draw label
  jfloadmap(a,m1,m2,0,0, 0,0);                   // show map
  c=getchar();
  jfend(0);
}
